const max = 10;
const arg = process.argv;
const os = require('os');
const fs = require('fs');
var cpu = os.cpus().length;
const path = require('path');
const {md5} = require('rrid');
const logs = require('../plug-in/colorLog');
const {kill,check} = require('../plug-in/psNode');
const {run,start} = require('../plug-in/fk2Path');
const addJson = require('../plug-in/addJSON');
module.exports = {
    async runFun(){
        // 主进程
        logs.g('Service is starting , please later ...');
        logs.close();
        if (arg[2] == 'start') {
            // fk2 start ...
            cpu = cpus(arg[4]);
            var data = readFile(start);
            if(!data) return 0;
            const id = md5(process.cwd()+arg[3]);
            if(data[id]&&data[id].ppid){
                const res = await check(data[id].ppid)
                if(res) {
                    console.log(res);
                    logs.r(arg[3]+ ' already open!')
                    return 0;
                }
            }
            data[id] = {
                cwd: process.cwd(),
                script: arg[3],
                pids:{},
                ppid: process.pid,
                close:'0',
                time: new Date().getTime()
            }
            addJson(start,data);
        } else {
            require('../auth');// json验证集群是否被绑定
            cpu = cpus(arg[3]);
            var data = readFile(run);
            if(!data) return 0;
            if(data.ppid){
                const res = await check(data.ppid)
                if(res) {
                    console.log(res);
                    logs.r('Fk2 already open!')
                    return 0;
                }
            }
            data.pids = {};
            data.ppid = process.pid;
            data.close = '0',
            data.time = new Date().getTime();
            addJson(run,data);
        }
        return cpu;
    },
    startFun(){
        // 工作进程
        if(arg[2]== 'start'){
            var data = readFile(start);
            if(!data) return 0;
            data[md5(process.cwd()+arg[3])].pids[process.pid] = '1';
            addJson(start,data);
        }else{
            var data = readFile(run);
            if(!data) return 0;
            data.pids[process.pid] = '1';
            addJson(run,data);
        }
    },
    onExit(pid){
        // 监听退出判断是否重启 0不重启
        if(arg[2]=='start'){
            var data = readFile(start);
            if(!data) return false;
            const id = md5(process.cwd()+arg[3]);
            const res = data[id].pids[pid];
            delete data[id].pids[pid];
            addJson(start,data);
            if(res > 0){
                return true;
            }else{
                return false;
            }
        }else{
            var data = readFile(run);
            if(!data) return false;
            const res = data.pids[pid];
            delete data.pids[pid];
            addJson(run,data);
            if(res > 0){
                return true;
            }else{
                return false;
            }
        }
    },
    exist(){
        // 为省略.js和.ts 后缀
        var paths = path.join(process.cwd(), arg[3]);
        if (!fs.existsSync(paths)) {
            // 简写.js和.ts
            if (fs.existsSync(paths + '.js')) {
                paths = paths + '.js';
            } else if (fs.existsSync(paths + '.ts')) {
                paths = paths + '.ts';
            } else {
                logs.r('Can not find ' + arg[3] + ' script!');
                logs.r('error path: ' + paths);
                logs.close();
                paths = false;
            }
        }
        return paths;
    },
    watch(){
        // 监听文件是否有重启动作
        if(arg[2]=='start'){
            fs.watchFile(start, async(cur, prv) => {
                // 监听文件
                if (cur.mtime !== prv.mtime) {
                    var data = readFile(start);
                    if(!data) return false;
                    const id = md5(process.cwd()+arg[3]);
                    if(data[id].close=='1'){
                        data[id].close='0';
                        addJson(start,data);
                        await kill(data[id].ppid);
                    }
                    restart(data[id].pids);
                }
            })
        }else{
            fs.watchFile(run, async(cur, prv) => {
                // 监听文件
                if (cur.mtime !== prv.mtime) {
                    var data = readFile(run);
                    if(!data) return false;
                    if(data.close=='1'){
                        data.close='0';
                        addJson(run,data);
                        await kill(data.ppid);
                    }
                    restart(data.pids);
                }
            })
        }
    }    
}
async function restart(pids) {
    if(Object.keys(pids).length>0){
        for (const key in pids) {
            if(pids[key]==0||pids[key]==3){
                //重启进程
                await kill(key);
            }
        }
        return pids
    }else{
        return false
    }
}
function readFile(url) {
    // 获取文件内容
    try {
        return  JSON.parse(fs.readFileSync(url));
    } catch (error) {
        logs.r(error);
        logs.close();
        return null;
    }
}
function cpus(d) {
    // 输出单例数
    if (d && d == 'max') {
        cpu = cpu;
    } else if (d && d > 0&&d<cpu+max+1) {
        cpu = d;
    } else {
        logs.r('Biggest process shall not be greater than '+cpu+max);
        logs.close();
        cpu = 1;
    }
    return cpu;
}